
# create a List

foo = [1,2,3,4,5]

# add a number to the end
foo.append(13)

# reaplace the number in index one with the number 0
foo[1] = 0

print foo

bar = []

# First show how map can create lists by
# applying a function to another list


def process(num):
	if num > 2:
		return [num, num*num]
	else:
		return "Nothing to map"
bar = map(process, foo)
	
print bar

bar = []		

for item in foo:
	if item > 2:	
		bar.append([item, item*item])		
print bar


bar = [[x,x*x] for x in foo if x > 2]
print bar




# ---------------------------------------------

# Use a list comprehension to apply a function to items in a list

class myClass:
	
	def __init__(self,color):
		self.color = color
		
	def getColor(self):
		return self.color

		
a1 = myClass("Red")
a2 = myClass("Blue")
a3 = myClass("Orange")
a4 = myClass("Green")

container = [a1,a2,a3,a4]

ucaseColors = [ a.getColor().upper() for a in container]
print ucaseColors



#------------------------------------------------------

# nested list comprehensions (stole from python docs)


mat = [
		[1, 2, 3],
		[4, 5, 6],
		[7, 8, 9],
       ]

# start from the outside: for i in [0,1,2]	   
print [[row[i] for row in mat] for i in [0, 1, 2]]


